;CROSS.LSP  copyright 1988  Fitzhugh Miller

;Douglas Paul INT routine, modified by 
;Fitzhugh L. Miller
;allows CROSS to be entered as a Command
(DEFUN C:CROSS ()
;display commands as they are run
(SETVAR "CMDECHO" 1)
;enable running Osnap Intersection
(COMMAND "OSNAP" "INT")
;prompts user to pick four intersections
(SETQ P1 (GETPOINT "1st INTERSECTION:"))
(SETQ P2 (GETPOINT "2nd INTERSECTION:"))
(SETQ P3 (GETPOINT "3rd INTERSECTION:"))
(SETQ P4 (GETPOINT "4th INTERSECTION:"))
;***************************************
;calculate midpoint P5
;
;extract just the X value of P1
(SETQ X1 (CAR P1))
;extract just the Y value of P1
(SETQ Y1 (CADR P1))
;extract just the X value of P2
(SETQ X2 (CAR P2))
;extract just the Y value of P2
(SETQ Y2 (CADR P2))
;subtract X2 from X1
(SETQ DIFFX1 (- X1 X2 ))
;subtract Y2 from Y1
(SETQ DIFFY1 (- Y1 Y2 ))
;half the difference of X1 and X2
(SETQ HDIFFX1 (/ DIFFX1 2))
;half the difference of Y1 and Y2
(SETQ HDIFFY1 (/ DIFFY1 2))
;add the half difference to X2
(SETQ X5 (+ X2 HDIFFX1))
;add the half difference to Y2
(SETQ Y5 (+ Y2 HDIFFY1))
;combine new X and Y into a coordinate
(SETQ P5 (LIST X5 Y5))
;***************************************
;calculate midpoint P6 in same manner
(SETQ X2 (CAR P2))
(SETQ Y2 (CADR P2))
(SETQ X3 (CAR P3))
(SETQ Y3 (CADR P3))
(SETQ DIFFX2 (- X2 X3 ))
(SETQ DIFFY2 (- Y2 Y3 ))
(SETQ HDIFFX2 (/ DIFFX2 2))
(SETQ HDIFFY2 (/ DIFFY2 2))
(SETQ X6 (+ X3 HDIFFX2))
(SETQ Y6 (+ Y3 HDIFFY2))
(SETQ P6 (LIST X6 Y6))
;***************************************
;calculate midpoint P7
(SETQ X3 (CAR P3))
(SETQ Y3 (CADR P3))
(SETQ X4 (CAR P4))
(SETQ Y4 (CADR P4))
(SETQ DIFFX3 (- X3 X4 ))
(SETQ DIFFY3 (- Y3 Y4 ))
(SETQ HDIFFX3 (/ DIFFX3 2))
(SETQ HDIFFY3 (/ DIFFY3 2))
(SETQ X7 (+ X4 HDIFFX3))
(SETQ Y7 (+ Y4 HDIFFY3))
(SETQ P7 (LIST X7 Y7))
;***************************************
;calculate midpoint P8
(SETQ X4 (CAR P4))
(SETQ Y4 (CADR P4))
(SETQ X1 (CAR P1))
(SETQ Y1 (CADR P1))
(SETQ DIFFX4 (- X4 X1 ))
(SETQ DIFFY4 (- Y4 Y1 ))
(SETQ HDIFFX4 (/ DIFFX4 2))
(SETQ HDIFFY4 (/ DIFFY4 2))
(SETQ X8 (+ X1 HDIFFX4))
(SETQ Y8 (+ Y1 HDIFFY4))
(SETQ P8 (LIST X8 Y8))
;***************************************
;set current PICKBOX equal to PBOXSIZE
(SETQ PBOXSIZE (GETVAR "PICKBOX"))
;change the PICKBOX size to 0 pixel
(SETVAR "PICKBOX" 0)
;turn the OSNAP off
(COMMAND "OSNAP" "NON")
;The actual TRIM routine
;Use the midpoints to select the cutting
;edges, null response to terminate edge
;selection, use midpoints to select the
;lines to be trimmed & null to end
(COMMAND "TRIM" P5 P6 P7 P8 "" 
  P5 P6 P7 P8 "")
;restore the original PICKBOX size
(SETVAR "PICKBOX" PBOXSIZE)
)
